;Development of this program was started by students from Department of Astronomy,
;Faculty of Mathematics, University of Belgrade, Serbia during summer practice
;(9.7.2007.-3.8.2007.) at Department of Solar Physics, Astronomical Institute of
;Academy of Science, Czech Republic.
;Reviewed, repaired and finished by Tomas Prosecky, PhD student at Solar Physics,
;Astronomical Institute of Academy of Science, Czech Republic

;This programe will load one picture and calculate mean value of intensities for the whole picture
;or for the ROI (Region Of Interest) in it, and plot histogram of it in the other window.
;The aim of the program is to recognize over/underexposed pixels and help observer
;to find correct exposure time.

;SHORT MANUAL
;After compiling and running Exposition.pro you have to select picture on the button 'Open file'.
;On the sliders 'Width of ROI' and 'Height of ROI' you can determine dimensions of rectangle witch
;will bound your ROI, and left click. It will give you mean intensity of bounded pixels in ROI
;in the label, and histogram of it.

;AUTHORS
;For all sugestions and complains please contact us:
;Neda Stojkovic, hipatija@gmail.com
;Tomas Prosecky, tomas.proso@post.cz

;COMMENT
;This is "beta version". Report all bugs to authors, please.

;Generated on:  28/08/2007




;=====================================================================
; Main program;-)
;=====================================================================
pro Exposition

common share1,analyze,rozmer,okno1,okno2,okno3
common share3,widroi,heiroi
common share6,under,over

    analyze=indgen(1280,512)
    analyze(*,*) = 0
    WID_BASE
    under=200
    over=3800

end

;=====================================================================
; Structure of widgets
;=====================================================================
pro WID_BASE

  device,set_graphics=3

  WID_BASE = Widget_Base(GROUP_LEADER=wGroup, UNAME='WID_BASE'  $
      ,XOFFSET=0 ,YOFFSET=0 ,SCR_XSIZE=1024 ,SCR_YSIZE=655 ,TITLE='Exposition' $
       ,SPACE=3 ,XPAD=3 ,YPAD=3)


  WID_BUTTON_0 = Widget_Button(WID_BASE, UNAME='Open_BUTTON'  $
      ,XOFFSET=15 ,YOFFSET=15 ,SCR_XSIZE=65 ,SCR_YSIZE=30  $
      ,/ALIGN_CENTER ,VALUE='Open file')

  WID_BUTTON_1 = Widget_Button(WID_BASE, UNAME='Done_BUTTON'  $
      ,XOFFSET=90 ,YOFFSET=15 ,SCR_XSIZE=65 ,SCR_YSIZE=30  $
      ,/ALIGN_CENTER ,VALUE='Exit')

  WID_BUTTON_2 = Widget_Button(WID_BASE, UNAME='ROI_BUTTON'  $
      ,XOFFSET=203 ,YOFFSET=15 ,SCR_XSIZE=60 ,SCR_YSIZE=47  $
      ,/ALIGN_CENTER , VALUE='roi.bmp', /BITMAP )


  WID_DRAW_0 = Widget_Draw(WID_BASE, UNAME='Hist_DRAW'  $
      ,XOFFSET=680 ,YOFFSET=80 ,SCR_XSIZE=320 ,SCR_YSIZE=200)

  WID_DRAW_1 = Widget_Draw(WID_BASE, UNAME='Over_DRAW'  $
      ,XOFFSET=680 ,YOFFSET=345 ,SCR_XSIZE=320 ,SCR_YSIZE=128)

  WID_DRAW_2 = Widget_Draw(WID_BASE, UNAME='Main_DRAW' ,FRAME=1  $
      ,XOFFSET=15 ,YOFFSET=80 ,SCR_XSIZE=640 , SCR_YSIZE=529 ,/SCROLL  $
      ,XSIZE=1280 ,YSIZE=512 ,/BUTTON_EVENTS ,/MOTION_EVENTS)


  WID_SLIDER_0 = Widget_Slider(WID_BASE, UNAME='WID_SLIDER_0'  $
      ,XOFFSET=346 ,YOFFSET=3 ,SCR_XSIZE=145 ,SCR_YSIZE=30,min=1,max=1280, VALUE=100)

  WID_SLIDER_1 = Widget_Slider(WID_BASE, UNAME='WID_SLIDER_1'  $
      ,XOFFSET=346 ,YOFFSET=33 ,SCR_XSIZE=145 ,SCR_YSIZE=30,min=1,max=512, VALUE=50)


  WID_LABEL_1 = Widget_Label(WID_BASE, UNAME='WID_LABEL_1'  $
      ,XOFFSET=273 ,YOFFSET=18 ,SCR_XSIZE=75 ,SCR_YSIZE=15  $
      ,/ALIGN_LEFT ,VALUE='Width of ROI:')

  WID_LABEL_2 = Widget_Label(WID_BASE, UNAME='WID_LABEL_2'  $
      ,XOFFSET=272 ,YOFFSET=48 ,SCR_XSIZE=75 ,SCR_YSIZE=15  $
      ,/ALIGN_LEFT ,VALUE='Height of ROI:')

  WID_LABEL_3 = Widget_Label(WID_BASE, UNAME='WID_LABEL_3'  $
      ,XOFFSET=15 ,YOFFSET=65 ,SCR_XSIZE=60 ,SCR_YSIZE=15  $
      ,/ALIGN_LEFT ,VALUE='Image')

  WID_LABEL_4 = Widget_Label(WID_BASE, UNAME='WID_LABEL_4'  $
      ,XOFFSET=680 ,YOFFSET=65 ,SCR_XSIZE=50 ,SCR_YSIZE=15  $
      ,/ALIGN_LEFT ,VALUE='Histogram')

  WID_LABEL_5 = Widget_Label(WID_BASE, UNAME='WID_LABEL_5'  $
      ,XOFFSET=680 ,YOFFSET=330 ,SCR_XSIZE=250 ,SCR_YSIZE=15  $
      ,/ALIGN_LEFT ,VALUE='Under/OverExposed parts of image')

  WID_LABEL_6 = Widget_Label(WID_BASE, UNAME='WID_LABEL_6'  $
      ,XOFFSET=533 ,YOFFSET=18 ,SCR_XSIZE=50 ,SCR_YSIZE=15 ,/ALIGN_LEFT  $
      ,VALUE='Position:')

  WID_LABEL_7 = Widget_Label(WID_BASE, UNAME='WID_LABEL_7' ,FRAME=1  $
      ,XOFFSET=583 ,YOFFSET=16 ,SCR_XSIZE=70 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='---')

  WID_LABEL_8 = Widget_Label(WID_BASE, UNAME='WID_LABEL_8'  $
      ,XOFFSET=532 ,YOFFSET=48 ,SCR_XSIZE=50 ,SCR_YSIZE=15 ,/ALIGN_LEFT  $
      ,VALUE='Intensity:')

  WID_LABEL_9 = Widget_Label(WID_BASE, UNAME='WID_LABEL_9' ,FRAME=1  $
      ,XOFFSET=583 ,YOFFSET=46 ,SCR_XSIZE=70 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='---')

  WID_LABEL_0 = Widget_Label(WID_BASE, UNAME='WID_LABEL_0'  $
      ,XOFFSET=680 ,YOFFSET=290 ,SCR_XSIZE=180 ,SCR_YSIZE=15  $
      ,TRACKING_EVENTS=1 ,/ALIGN_LEFT ,VALUE='Mean value of intensity of given ROI:')

  WID_LABEL_10 = Widget_Label(WID_BASE, UNAME='WID_LABEL_10'  $
      ,FRAME=1 ,XOFFSET=864 ,YOFFSET=288 ,SCR_XSIZE=60 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='---')


  WID_LABEL_21 = Widget_Label(WID_BASE, UNAME='WID_LABEL_21'  $
      ,XOFFSET=680 ,YOFFSET=500 ,SCR_XSIZE=100 ,SCR_YSIZE=15  $
      ,/ALIGN_LEFT ,VALUE='Image parameters:')

  WID_LABEL_11 = Widget_Label(WID_BASE, UNAME='WID_LABEL_11'  $
      ,XOFFSET=680 ,YOFFSET=518 ,SCR_XSIZE=87 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='Exposure time:')

  WID_LABEL_12 = Widget_Label(WID_BASE, UNAME='WID_LABEL_12'  $
      ,FRAME=1 ,XOFFSET=767 ,YOFFSET=516 ,SCR_XSIZE=70 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='---')

  WID_LABEL_17 = Widget_Label(WID_BASE, UNAME='WID_LABEL_17'  $
      ,XOFFSET=680 ,YOFFSET=533 ,SCR_XSIZE=87 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='Line:')

  WID_LABEL_18 = Widget_Label(WID_BASE, UNAME='WID_LABEL_18'  $
      ,FRAME=1 ,XOFFSET=767 ,YOFFSET=531 ,SCR_XSIZE=70 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='---')

  WID_LABEL_13 = Widget_Label(WID_BASE, UNAME='WID_LABEL_13'  $
      ,XOFFSET=680 ,YOFFSET=548 ,SCR_XSIZE=87 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='Date:')

  WID_LABEL_14 = Widget_Label(WID_BASE, UNAME='WID_LABEL_14'  $
      ,FRAME=1 ,XOFFSET=767 ,YOFFSET=546 ,SCR_XSIZE=70 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='---')

  WID_LABEL_15 = Widget_Label(WID_BASE, UNAME='WID_LABEL_15'  $
      ,XOFFSET=680 ,YOFFSET=563 ,SCR_XSIZE=87 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='Time:')

  WID_LABEL_16 = Widget_Label(WID_BASE, UNAME='WID_LABEL_16'  $
      ,FRAME=1 ,XOFFSET=767 ,YOFFSET=561 ,SCR_XSIZE=70 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='---')

  WID_LABEL_19 = Widget_Label(WID_BASE, UNAME='WID_LABEL_19'  $
      ,XOFFSET=680 ,YOFFSET=578 ,SCR_XSIZE=87 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='Type of data:')

  WID_LABEL_20 = Widget_Label(WID_BASE, UNAME='WID_LABEL_20'  $
      ,FRAME=1 ,XOFFSET=767 ,YOFFSET=576 ,SCR_XSIZE=70 ,SCR_YSIZE=15  $
      ,/ALIGN_CENTER ,VALUE='---')

  Widget_Control, /REALIZE, WID_BASE
  XManager, 'WID_BASE', WID_BASE, /NO_BLOCK
end

;=====================================================================
;Exit from the program
;=====================================================================
pro OnExit, Event

widget_control,event.top,/destroy

end

;=====================================================================
; Widgets events
;=====================================================================
pro WID_BASE_event, Event

  wWidget = Event.top

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Open_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then OpenFile, Event
    end

    Widget_Info(wWidget, FIND_BY_UNAME='Done_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        OnExit, Event
    end

    Widget_Info(wWidget, FIND_BY_UNAME='ROI_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        ResultFull, Event
    end

    Widget_Info(wWidget, FIND_BY_UNAME='Main_DRAW'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DRAW' )then $
        if (event.press eq 1) then Result , Event
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DRAW' )then $
        if (event.press eq 4) then print, 'Do not use right button;-)!'
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DRAW' )then $
        if (event.press eq 2) then print, 'Do not use middle button;-)!'
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DRAW' )then $
        if( Event.type eq 2)then GetValue, Event
    end

    else:
  endcase

end

;=====================================================================
;Handling the screens and opening .fts file, and showing the
;thumbnail of the image in the other screen
;=====================================================================
pro OpenFile, Event

common share1,analyze,rozmer,okno1,okno2,okno3
common share6,under,over
common share7,extime

filer = ''
komplexcesty = filer+dialog_pickfile(/MUST_EXIST, TITLE='Pick an Image', FILTER=['*.fts', '*.fit'], GET_PATH=cesta, /READ)
print, komplexcesty
print,'path = ', cesta
delkacesty=STRLEN(cesta)
delkakomplex=STRLEN(komplexcesty)
delkafilu=delkakomplex-delkacesty
soubor=STRMID(komplexcesty,delkacesty,delkafilu)
print,'The file to be analyzed: ', soubor

analyze = readfits(soubor,header)
rozmer=size(analyze)

if rozmer(0) EQ 0 then begin
    analyze=indgen(1280,512)
    analyze(*,*) = 0
    wset,okno1 & erase & wset,okno2 & erase & wset,okno3 & erase
    wset,okno1 & tvscl,analyze

    extimeID=widget_info(Event.top,find_by_uname='WID_LABEL_12')
    widget_control,extimeID,set_value='---'

    dateID=widget_info(Event.top,find_by_uname='WID_LABEL_14')
    widget_control,dateID,set_value='---'

    tmID=widget_info(Event.top,find_by_uname='WID_LABEL_16')
    widget_control,tmID,set_value='---'

    lineID=widget_info(Event.top,find_by_uname='WID_LABEL_18')
    widget_control,lineID,set_value='---'

    typeID=widget_info(Event.top,find_by_uname='WID_LABEL_20')
    widget_control,typeID,set_value='---'

	Label10=widget_info(Event.top,find_by_uname='WID_LABEL_10')
	widget_control,Label10,set_value='---'

endif else begin
im=widget_info(Event.top,find_by_uname='Main_DRAW')
widget_control,im,get_value=okno1
winhis=widget_info(Event.top,find_by_uname='Hist_DRAW')
widget_control,winhis,get_value=okno2
uoroi=widget_info(Event.top,find_by_uname='Over_DRAW')
widget_control,uoroi,get_value=okno3

wset,okno1 & erase & wset,okno2 & erase & wset,okno3 & erase

thumbnail=congrid(analyze,320,128,/interp)

wset,okno3 & erase & tvscl,thumbnail >under <over

CONTOUR, thumbnail, LEVELS = over, TICKLEN = 0, C_COLORS = [255], XRANGE = [0,320], YRANGE = [0,128], YSTYLE = 1, XSTYLE = 1, XMARGIN = [0,0], YMARGIN = [0,0], YTICKLAYOUT = 1, XTICKLAYOUT =1, /NOERASE
CONTOUR, thumbnail, LEVELS = under, TICKLEN = 0, C_COLORS = [9109504], XRANGE = [0,320], YRANGE = [0,128], YSTYLE = 1, XSTYLE = 1, XMARGIN = [0,0], YMARGIN = [0,0], YTICKLAYOUT = 1, XTICKLAYOUT =1, /NOERASE

wset,okno1 & tvscl,analyze

    ;----------------------------------------
    ;reading the time of exposition, date, time, line and type of data from the filename
    ;----------------------------------------
    first=strpos(soubor,'s_voss')

    extime=strmid(soubor,first+32,3)
    extimeID=widget_info(Event.top,find_by_uname='WID_LABEL_12')
    widget_control,extimeID,set_value=extime+' ms'

    day=strmid(soubor,first+7,2)
    month=strmid(soubor,first+10,2)
    year=strmid(soubor,first+13,2)
    dateID=widget_info(Event.top,find_by_uname='WID_LABEL_14')
    widget_control,dateID,set_value=day+'.'+month+'.'+year+'.'

    hour=strmid(soubor,first+16,2)
    minute=strmid(soubor,first+19,2)
    sec=strmid(soubor,first+22,4)
    tmID=widget_info(Event.top,find_by_uname='WID_LABEL_16')
    widget_control,tmID,set_value=hour+':'+minute+':'+sec

    line=strmid(soubor,first+27,2)
    lineID=widget_info(Event.top,find_by_uname='WID_LABEL_18')
    widget_control,lineID,set_value=line

    type=strmid(soubor,first+30,1)
    typeID=widget_info(Event.top,find_by_uname='WID_LABEL_20')
    widget_control,typeID,set_value=type

Label10=widget_info(Event.top,find_by_uname='WID_LABEL_10')
widget_control,Label10,set_value='---'
endelse
end

;=====================================================================
;Ploting rectangle
;=====================================================================
PRO rectangle,xx,yy,sirka,vyska ;nakresli obdelnik

device,set_graphics=old
px=[xx-sirka/2,xx-sirka/2+sirka,xx-sirka/2+sirka,xx-sirka/2,xx-sirka/2]
py=[yy-vyska/2,yy-vyska/2,yy-vyska/2+vyska,yy-vyska/2+vyska,yy-vyska/2]
plots,px,py,/dev,thick=2,lines=0,color=65535 ;65535=yellow
END

;=====================================================================
;Finding mean value of intensity of pixels of ROI (Region Of Interest)
;and ploting histogram of ROI
;=====================================================================
pro Result, Event

common share1,analyze,rozmer,okno1,okno2,okno3
common share2,x,y
common share3,widroi,heiroi
common share6,under,over
common share8,hiss,roi

if mean(analyze) EQ 0 then begin

    ErrorBase = Widget_Base( GROUP_LEADER=wGroup, UNAME='WID_BASE_3'  $
        ,XOFFSET=745 ,YOFFSET=165 ,SCR_XSIZE=200 ,SCR_YSIZE=80 ,TITLE='Error...'  $
        ,SPACE=3 ,XPAD=3 ,YPAD=3)
    ErrorLabel = Widget_Label(ErrorBase, UNAME='ErrorLabel'  $
        ,XOFFSET=20 ,YOFFSET=20 ,SCR_XSIZE=160 ,SCR_YSIZE=20  $
        ,/ALIGN_CENTER ,VALUE='NO FILE LOADED!')
    Widget_Control, /REALIZE, ErrorBase
    XManager, 'ErrorBase', ErrorBase, /NO_BLOCK
    wait, 1
    widget_control,ErrorBase,/destroy

endif else begin

if ((x-widroi/2) gt 0) and ((x-widroi/2+widroi) lt 1280) and $
   ((y-heiroi/2) gt 0) and ((y-heiroi/2+heiroi) lt 512) then begin

roi=analyze[x-widroi/2:x-widroi/2+widroi-1,y-heiroi/2:y-heiroi/2+heiroi-1]

meanint=total(roi)/(widroi*heiroi)
Label10=widget_info(Event.top,find_by_uname='WID_LABEL_10')
widget_control,Label10,set_value=string(meanint)

hiss=histogram(roi)
bins = FINDGEN(N_ELEMENTS(hiss)) + MIN(roi)

wset, okno2
PLOT, bins, hiss, XRANGE = [0,4095], YRANGE = [0, MAX(hiss)+5], XMARGIN = [5,2], YMARGIN = [2,1], YSTYLE = 1, XSTYLE = 1

overexposed = INDGEN(MAX(hiss)+5,2)
overexposed(*,1) = over
OPLOT, overexposed(*,1), overexposed(*,0), linestyle = 0, COLOR = get_color('red')

underexposed = INDGEN(MAX(hiss)+5,2)
underexposed(*,1) = under
OPLOT, underexposed(*,1), underexposed(*,0), linestyle = 0, COLOR = get_color('darkblue')

endif
endelse
end

;=====================================================================
;Finding mean value of intensity of pixels and ploting histogram of full CCD
;=====================================================================

pro ResultFull, Event

common share1,analyze,rozmer,okno1,okno2,okno3
common share2,x,y
common share3,widroi,heiroi
common share6,under,over
common share8,hiss,roi

Label10=widget_info(Event.top,find_by_uname='WID_LABEL_10')

roi=analyze[0:0+1280-1,0:0+512-1]

if mean(analyze) EQ 0 then begin

    ErrorBase = Widget_Base( GROUP_LEADER=wGroup, UNAME='WID_BASE_3'  $
        ,XOFFSET=745 ,YOFFSET=165 ,SCR_XSIZE=200 ,SCR_YSIZE=80 ,TITLE='Error...'  $
        ,SPACE=3 ,XPAD=3 ,YPAD=3)
    ErrorLabel = Widget_Label(ErrorBase, UNAME='ErrorLabel'  $
        ,XOFFSET=20 ,YOFFSET=20 ,SCR_XSIZE=160 ,SCR_YSIZE=20  $
        ,/ALIGN_CENTER ,VALUE='NO FILE LOADED!')
    Widget_Control, /REALIZE, ErrorBase
    XManager, 'ErrorBase', ErrorBase, /NO_BLOCK
    wait, 1
    widget_control,ErrorBase,/destroy

endif else begin
meanint=total(roi)/(655360) ;655360=1280*512
widget_control,Label10,set_value=string(meanint)

hiss=histogram(roi)
bins = FINDGEN(N_ELEMENTS(hiss)) + MIN(roi)

wset, okno2
PLOT, bins, hiss, XRANGE = [0,4095], YRANGE = [0, MAX(hiss)+5], XMARGIN = [5,2], YMARGIN = [2,1], YSTYLE = 1, XSTYLE = 1

overexposed = INDGEN(MAX(hiss)+5,2)
overexposed(*,1) = over
OPLOT, overexposed(*,1), overexposed(*,0), linestyle = 0, COLOR = get_color('red')

underexposed = INDGEN(MAX(hiss)+5,2)
underexposed(*,1) = under
OPLOT, underexposed(*,1), underexposed(*,0), linestyle = 0, COLOR = get_color('darkblue')

endelse
end

;=====================================================================
;printing position and intensity of the individual pixels
;(on moving cursor)
;=====================================================================

pro GetValue, Event

common share1,analyze,rozmer,okno1,okno2,okno3
common share2,x,y
common share3,widroi,heiroi

im=widget_info(Event.top,find_by_uname='Main_DRAW')
widget_control,im,get_value=okno1

wset, okno1
tvscl,analyze

Label7=widget_info(Event.top,find_by_uname='WID_LABEL_7')
widget_control,Label7,set_value=strcompress('('+string(event.x)+','+string(event.y)+')')

Label9=widget_info(Event.top,find_by_uname='WID_LABEL_9')
widget_control,Label9,set_value=string(analyze(event.x,event.y))

Slider0=widget_info(Event.top,find_by_uname='WID_SLIDER_0')
widget_control,Slider0,get_value=widroi

Slider1=widget_info(Event.top, find_by_uname='WID_SLIDER_1')
widget_control,Slider1,get_value=heiroi

x=event.x
y=event.y

if ((x-widroi/2) gt 0) and ((x-widroi/2+widroi) lt 1280) and $
   ((y-heiroi/2) gt 0) and ((y-heiroi/2+heiroi) lt 512) then begin
rectangle,x,y,widroi,heiroi
endif

end



